'use strict';

var vanilla = require('zustand/vanilla');
var ReactExports = require('react');
var useSyncExternalStoreExports = require('use-sync-external-store/shim/with-selector');

var useDebugValue = ReactExports.useDebugValue;
var useSyncExternalStoreWithSelector = useSyncExternalStoreExports.useSyncExternalStoreWithSelector;
var identity = function identity(arg) {
  return arg;
};
function useStore(api, selector) {
  if (selector === void 0) {
    selector = identity;
  }
  var slice = useSyncExternalStoreWithSelector(api.subscribe, api.getState, api.getInitialState, selector);
  useDebugValue(slice);
  return slice;
}
var createImpl = function createImpl(createState) {
  var api = vanilla.createStore(createState);
  var useBoundStore = function useBoundStore(selector) {
    return useStore(api, selector);
  };
  Object.assign(useBoundStore, api);
  return useBoundStore;
};
var create = function create(createState) {
  return createState ? createImpl(createState) : createImpl;
};

exports.create = create;
exports.useStore = useStore;
Object.keys(vanilla).forEach(function (k) {
  if (k !== 'default' && !Object.prototype.hasOwnProperty.call(exports, k)) Object.defineProperty(exports, k, {
    enumerable: true,
    get: function () { return vanilla[k]; }
  });
});
